<?php
require_once "PerLeDi.class.php";
require_once "lib/classes/Seminar.class.php";
if(!class_exists("PluginVisits")){
	require_once "PluginVisits.class.php";
}
class PerLeDiPlugin extends AbstractStudIPStandardPlugin {

	var $template_factory;
	var $config = array();
	var $perpage = 5;
	var $perle = null;

	/**
	 *
	 */
	function PerLeDiPlugin(){
		AbstractStudIPStandardPlugin::AbstractStudIPStandardPlugin();
		$this->setPluginiconname('images/icon-posting.gif');
		$this->setChangeindicatoriconname('images/icon-posting2.gif');
		$this->template_factory = new Flexi_TemplateFactory(dirname(__FILE__).'/templates/');
		$navigation = new PluginNavigation();
		$navigation->addLinkParam('action', 'main');
		$navigation->setDisplayname($this->getDisplayTitle());
		if ($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			$config_nav = new PluginNavigation();
			$config_nav->setDisplayname(_("Anpassen"));
			$config_nav->addLinkParam('action', 'config');
			$navigation->addSubmenu($config_nav);
		}
		$this->setNavigation($navigation);
	}


	function getPluginName(){
		return 'Perle';
	}

	function getDisplayTitle(){
		$this->restoreConfig();
		return $this->config['PERLE_DISPLAYNAME'] ? $this->config['PERLE_DISPLAYNAME'] : _("Persnlicher Lerndialog");
	}

	function isShownInOverview(){
		$this->restoreConfig();
		$this->initPerle();
		$this->perle->getMembersPostings($this->getLastVisits('visitdate'));
		return $this->countPostings() || $this->config['PERLE_INFOTEXT'] != '';
	}


	function getOverviewMessage($has_changed = false){
		$postings =  $this->countPostings();
		$ret = $this->getDisplayTitle();
		if($postings) {
			$ret .= ': ' . $this->countPostings() . ' Beitrge';
			if($has_changed){
				$ret .= ','.$this->countPostings('new_postings') . ' Neue';
			}
		}
		return $ret;
	}

	function hasChanged($lastviewed){
		return $this->countPostings('new_postings');
	}

	function countPostings($count_what = 'postings'){
		$count = 0;
		if($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			foreach($this->perle->members as $member) $count += $member[$count_what];
		} else {
			$count = $this->perle->members[$GLOBALS['user']->id][$count_what == 'new_postings' ? 'new_postings_for_student' : 'postings'];
		}
		return $count;
	}

	function getLastVisits($mode = 'last'){
		$last_visits = array();
		if($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			foreach($this->perle->members as $user_id => $data){
				$last_visits[$user_id] = PluginVisits::GetVisit($this, $user_id, 'member', $GLOBALS['user']->id, $mode);
			}
		} else {
			$last_visits[$GLOBALS['user']->id] = PluginVisits::GetVisit($this, $GLOBALS['user']->id, 'member', $GLOBALS['user']->id, $mode);
		}
		return $last_visits;
	}

	function display_action($action) {
		PluginVisits::SetVisit($this);
		include 'lib/include/html_head.inc.php';
		include 'lib/include/header.php';
		$this->$action();
		include 'lib/include/html_end.inc.php';
	}

	function actionPrintview(){
		if($GLOBALS['perm']->have_studip_perm('autor', $this->getId())){
		$this->initPerle();
		$seminar = Seminar::GetInstance($this->getId());
		$semester = SemesterData::GetInstance();
		$seminar_semester = $semester->getSemesterDataByDate($seminar->getSemesterStartTime());
		$dozenten = join(', ', array_map(create_function('$a', 'return $a["Nachname"];'), $seminar->getMembers('dozent')));
		if(!$GLOBALS['perm']->have_studip_perm('tutor', $this->getId()) ){
			$this->perle->user_id = $GLOBALS['user']->id;
		}
		$GLOBALS['_include_stylesheet'] = "style_print.css";
		include 'lib/include/html_head.inc.php';
		echo "\n" . '<h1>' . htmlReady(sprintf("%s - %s (%s)", $seminar->getName(), $seminar_semester['name'], $dozenten)) . '</h1>';
		echo "\n" . '<h2>' . htmlReady($this->config['PERLE_DISPLAYNAME']) . '</h2>';
		echo "\n" . '<p>' . formatready($this->config['PERLE_INFOTEXT'], true, true) . '</p>';
		echo "\n" . '<h2>' . _("Dialog mit ") . htmlReady($this->perle->members[$this->perle->user_id]['fullname']) . '</h2>';
		$postings = $this->perle->getPostings(0, 1000);
		foreach($postings as $posting){

			$number = count($postings) - $c++;
			echo "\n" .'<h4>' . sprintf(_("%s - %s hat am %s geschrieben:"),$number, htmlready($posting['fullname']), date('d.m.Y - H:i', $posting['chdate'])) . '</h4>';
			echo "\n" . '<p>' . quotes_decode(formatready($posting["content"], true, true)) . '</p>';
		}
		include 'lib/include/html_end.inc.php';
		page_close();
		}
	}

	function actionShow(){
		$GLOBALS['CURRENT_PAGE'] =
			$_SESSION['SessSemName']['header_line'] . ' - ' . $this->getDisplayTitle();

		if($_REQUEST['action'] == 'config'){
			$this->displayConfigPage();
		} else {
			$this->displayMainPage();
		}
	}

	function displayConfigPage(){
        $msg = array();
		if(isset($_REQUEST['save_x'])){
			$name = stripslashes(trim($_REQUEST['perle_displayname']));
			$text = stripslashes(trim($_REQUEST['perle_infotext']));
			$sort = (int)$_REQUEST['perle_sortby'];
			$this->config['PERLE_DISPLAYNAME'] = $name;
			$this->config['PERLE_INFOTEXT'] = $text;
			$this->config['PERLE_SORTBY'] = $sort;
			if($this->storeConfig()){
					$msg[] = array('msg', _("Die Einstellungen wurden gespeichert."));
				}

		}

		$template = $this->template_factory->open('config');
		$template->set_attribute('msg', $msg);
        $template->set_attribute('plugin', $this);
		$template->set_attribute('config', $this->config);
        echo $template->render();
	}

	function displayMainPage(){
		$msg = array();
		$this->initPerle();
		$last_visit = PluginVisits::GetVisit($this);
		if($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			$show_user_chooser = true;
			if(isset($_REQUEST['perle_choose_user']) || isset($_REQUEST['send_posting_x'])){
				$this->perle->user_id = $_REQUEST['perle_choose_user'];
			}
			if(isset($_REQUEST['assert_kill_all_x'])){
				$msg[] = array('info',
				'Wollen Sie wirklich alle Beitrge lschen?
				<br>
				<a href="'.PluginEngine::getLink($this, array('action' => 'kill_all')).'">'
				. makeButton('ja2')
				.'</a>&nbsp;<a href="'.PluginEngine::getLink($this).'">'
				. makeButton('nein')
				. '</a>');
			}
			if(isset($_REQUEST['assert_kill_one_x'])){
				$msg[] = array('info',
				'Wollen Sie wirklich alle Beitrge fr '.htmlready($this->perle->members[$this->perle->user_id]['fullname']).' lschen?
				<br>
				<a href="'.PluginEngine::getLink($this, array('action' => 'kill_one')).'">'
				. makeButton('ja2')
				.'</a>&nbsp;<a href="'.PluginEngine::getLink($this).'">'
				. makeButton('nein')
				. '</a>');
			}
			if($_REQUEST['action'] == 'kill_all'){
				if($count = $this->perle->deleteAllPostings()){
					$msg[] = array('msg', sprintf(_("Es wurden alle %s Beitrge gelscht."), $count));
				}
			}
			if($_REQUEST['action'] == 'kill_one'){
				if($count = $this->perle->deleteAllPostings($this->perle->user_id)){
					$msg[] = array('msg', sprintf(_("Es wurden alle %s Beitrge fr %s gelscht."), $count, htmlready($this->perle->members[$this->perle->user_id]['fullname'])));
				}
			}
		} else {
			$this->perle->user_id = $GLOBALS['user']->id;
			$show_user_chooser = false;
		}
		if(isset($_REQUEST['send_posting_x'])){
			if($_REQUEST['perle_id']){
				$posting = $this->perle->getPosting($_REQUEST['perle_id']);
				if($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root')){
					if($this->perle->updatePosting($_REQUEST['perle_id'], stripslashes(trim($_REQUEST['new_posting'])))){
						$msg[] = array('msg',"Ihr Beitrag wurde gendert.");
					}
				}
			} else {
				if($this->perle->addPosting(stripslashes(trim($_REQUEST['new_posting'])))){
					$msg[] = array('msg',"Ihr Beitrag wurde hinzugefgt.");
				}
			}
		}
		if($_REQUEST['action'] == 'quote'){
			$posting = $this->perle->getPosting($_REQUEST['perle_id']);
			if($posting['content']){
				$quoted_posting = quotes_encode($posting['content'], $posting['fullname']);
			}
		}
		if($_REQUEST['action'] == 'edit'){
			$posting = $this->perle->getPosting($_REQUEST['perle_id']);
			if($posting['content'] && ($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root'))){
				$quoted_posting = $posting['content'];
			}
		}
		if($_REQUEST['action'] == 'kill'){
			$posting = $this->perle->getPosting($_REQUEST['perle_id']);
			if($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root')){
				if($this->perle->killPosting($posting['perle_id'])){
					$msg[] = array('msg',"Ihr Beitrag wurde gelscht.");
				}
			}
		}
		$this->perle->getMembersPostings($this->getLastVisits('visit'));
		if(!$this->perle->user_id || !$this->perle->members[$this->perle->user_id]) $this->perle->user_id = key($this->perle->members);
		if(!count($this->perle->members)){
			$msg[] = array('info', _("In dieser Veranstaltung sind noch keine Teilnehmer eingetragen!."));
		} else {
			PluginVisits::SetVisit($this, $this->perle->user_id, 'member');
		}
		$this->perle->getMembersPostings($this->getLastVisits('visit'));
		$template = $this->template_factory->open('main');
		$template->set_attribute('msg', $msg);
        $template->set_attribute('plugin', $this);
		$template->set_attribute('perle', $this->perle);
		$template->set_attribute('quoted_posting', $quoted_posting);
		$template->set_attribute('edit_perle_id', ($_REQUEST['action'] == 'edit' ? $_REQUEST['perle_id'] : ''));
		$template->set_attribute('show_user_chooser', $show_user_chooser);
		$template->set_attribute('last_visits', $this->getLastVisits('last'));
		echo $template->render();
	}

	function restoreConfig($seminar_id = ''){
		$this->config = array();
		$db = new DB_Seminar();
		if($this->getId() == UNKNOWN_ID) $id = $seminar_id;
		else $id = $this->getId();
		$db->queryf("SELECT * FROM user_config WHERE user_id='%s' AND field LIKE 'PERLE%%'", $id);
		while($db->next_record()){
			$this->config[$db->f('field')] = $db->f('value');
		}
		return count($this->config);
	}

	function storeConfig(){
		$ret = 0;
		$new_config = $this->config;
		$this->restoreConfig();
		$db = new DB_Seminar();
		foreach($new_config as $field => $value){
			if($this->config[$field] != $value){
				$db->queryf("REPLACE INTO user_config (user_id, userconfig_id, field, value, chdate) VALUES ('%s','%s','%s','%s', UNIX_TIMESTAMP())",
							$this->getId(), md5($field), $field, mysql_escape_string($value));
				++$ret;
			}
		}
		$this->restoreConfig();
		return $ret;
	}

	function getNavi($maxpostings) {
		$i = 1;
		$ipage = $_REQUEST['currentpage'] ? abs($_REQUEST['currentpage'])  : 1;
		$maxpages = (int)($maxpostings / $this->perpage) +1;
		if ($ipage != 1){
			$navi .= "<a href=\"".PluginEngine::getLink($this)."&currentpage=".($ipage-1)."\"><font size=-1>" . _("zurck") . "</a> | </font>";
		} else {
			$navi .= "<font size=\"-1\">Seite: </font>";
		}
		while ($i <= $maxpages) {
			if ($i == 1 || $i+2 == $ipage || $i+1 == $ipage || $i == $ipage || $i-1 == $ipage || $i-2 == $ipage || $i == $maxpages) {
				if ($space == 1) {
					$navi .= "<font size=-1>... | </font>";
					$space = 0;
				}
				if ($i != $ipage) $navi .= "<a href=\"".PluginEngine::getLink($this)."&currentpage=".$i."\"><font size=-1>".$i."</a></font>";
				else $navi .= "<font size=\"-1\"><b>".$i."</b></font>";
				if ($maxpages != 1) $navi .= "<font size=\"-1\"> | </font>";
			} else {
				$space = 1;
			}
			$i++;
		}
		if ($ipage != $maxpages) $navi .= "<a href=\"".PluginEngine::getLink($this)."&currentpage=".($ipage+1)."\"><font size=-1> " . _("weiter") . "</a></font>";
		return $navi;
	}

	function initPerle(){
		if(is_null($this->perle)){
			$this->perle = new PerLeDi($this->getId(), $this->config);
		}
	}
}
?>